using System.Collections.Generic;
using System.Security.Cryptography.X509Certificates;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;

namespace matopeli;

/// @author Omanimi
/// @version 30.10.2023
/// <summary>
/// 
/// </summary>
public class matopeli : PhysicsGame
{
    private Objektit Mato;
    public double MatoX;
    public double MatoY;
    public int SuuntaX;
    public int SuuntaY;
    
    private static readonly Image seinakuva = LoadImage("seina.png");
    private static readonly Image matopaakuva = LoadImage("matopaa.png");
    private readonly Image matokehokuva = LoadImage("matokeho.png");
    private readonly Image omenakuva = LoadImage("omena.png");
    private readonly Image kenttatausta = LoadImage("kenttatausta.png");
    
    private bool SuuntaYlos = false;
    private bool SuuntaAlas = false;
    private bool SuuntaOikea = false;
    private bool SuuntaVasen = false;
    
    public override void Begin()
    {
        // Kirjoita ohjelmakoodisi tähän

        PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
        AloitaUusiPeli();
        
    }

    public void AloitaUusiPeli()
    {
        ClearAll();
        SuuntaAlas = true;
        LuoMato();
        Asetaohjaimet();
        LuoAikalaskuri();
    }
    private void Asetaohjaimet()
    {
        Keyboard.Listen(Key.Up, ButtonState.Pressed, VaihdaSuuntaYlos, "Turn upwards");
        Keyboard.Listen(Key.Down, ButtonState.Pressed, VaihdaSuuntaAlas, "Turn downwards");
        Keyboard.Listen(Key.Left, ButtonState.Pressed, VaihdaSuuntaVasen , "Turn left");
        Keyboard.Listen(Key.Right, ButtonState.Pressed, VaihdaSuuntaOikea, "Turn right");
    }
    public PhysicsObject LuoMato()
    {
        Mato = new Objektit(60, 60, new Vector(0,0));
        Mato.Color = Color.Charcoal;
        Mato.Position = new Vector(0, 0);
        Add(Mato);
        Mato.Tag = "mato";
        return Mato;
    }

     private void VaihdaSuuntaYlos()
        {
            
            if (SuuntaAlas==true)
            {
                SuuntaOikea = false;
                SuuntaVasen = false;
                SuuntaYlos = false;
                SuuntaAlas = true;
            }
            else
            {
                SuuntaOikea = false;
                SuuntaVasen = false;
                SuuntaYlos = true;
                SuuntaAlas = false;
            }
        }
     
     private void VaihdaSuuntaAlas()
        {
            if (SuuntaYlos==true)
            {
                SuuntaOikea = false;
                SuuntaVasen = false;
                SuuntaYlos = true;
                SuuntaAlas = false;
            }
            else
            {
                SuuntaOikea = false;
                SuuntaVasen = false;
                SuuntaYlos = false;
                SuuntaAlas = true;
            }
        }
        
     private void VaihdaSuuntaOikea()
        {
            if (SuuntaVasen == true)
            {
                
                SuuntaOikea = false;
                SuuntaVasen = true;
                SuuntaYlos = false;
                SuuntaAlas = false;
            }
            else
            {
                SuuntaOikea = true;
                SuuntaVasen = false;
                SuuntaYlos = false;
                SuuntaAlas = false;
            }

        }
        
     private void VaihdaSuuntaVasen()
        {
            if (SuuntaOikea==true)
            {
                SuuntaOikea = true;
                SuuntaVasen = false;
                SuuntaYlos = false;
                SuuntaAlas = false;
            }
            else
            {
                SuuntaOikea = false;
                SuuntaVasen = true;
                SuuntaYlos = false;
                SuuntaAlas = false;
            }
        }
     private void LuoAikalaskuri()
        {
            Timer aikalaskuri = new Timer();
            aikalaskuri.Interval = 0.008;
            aikalaskuri.Timeout += LiikutaMatoa;
            aikalaskuri.Start();
        }

    private void LiikutaMatoa()
    {
        if (SuuntaYlos==true)
        {
            Mato.Y++;
        }
        if (SuuntaAlas==true)
        {
            Mato.Y--;
        }
        if (SuuntaOikea==true)
        {
            Mato.X++;
        }
        if (SuuntaVasen==true)
        {
            Mato.X--;
        }
        

    }

    private class Objektit : PhysicsObject
    {
         public Objektit(double leveys, double korkeus, Vector paikka)
        : base(leveys, korkeus)
        {
            Mass = 10000;
            IsUpdated = true;
        }
    }



}

        





        




    